#pragma once
#include "GuiComponent.hpp"
#include <raylibs/raygui.h>
#include <string>

namespace sva {
	class GuiMovableWindow : public sva::GuiComponent
	{
	private:
		bool m_DragWindow = false;
		Vector2 m_PanOffset = { 0,0 };
	protected:
		Rectangle m_WndRect = { 20,20, 200, 100 };
		bool m_WindowOpen = true;
		std::string m_Title;
	public:
		GuiMovableWindow();

		virtual int input() override;

		virtual int rinput(Vector2& mouse_position);
		virtual int rdraw();

		virtual int draw() override;
	};

	class ErrorWindow : public GuiMovableWindow
	{
		std::string m_Msg;
		Vector2 m_TextAnchor = { 0,0 };
	public:
		void onAttach() override;

		int rdraw() override;

		void onResize() override;

		void error(std::string title, std::string msg);
	};
}